/*****************************************************************************
 *
 *   Kinetic Technologies Ltd. 2006       
 *
 *   Authors	: Ilya Valuev, Alexei Deinega,  KINTECH, Moscow, Russia
 *
 *   Project	: FDTD-II
 *
 *   $Revision: 1.1 $
 *   $Date: 2012/12/06 02:24:05 $
 *   @(#) $Header: /home/dev/Photon/ivutils/src/ifmpi.cpp,v 1.1 2012/12/06 02:24:05 lesha Exp $
 *
 *****************************************************************************/
/*
$Source: /home/dev/Photon/ivutils/src/ifmpi.cpp,v $
$Revision: 1.1 $
$Author: lesha $
$Date: 2012/12/06 02:24:05 $
*/
/******************************************************************************
 * $Log: ifmpi.cpp,v $
 * Revision 1.1  2012/12/06 02:24:05  lesha
 * *** empty log message ***
 *
 * Revision 1.4  2012/10/17 06:50:09  lesha
 * documentation
 *
 * Revision 1.3  2012/05/11 15:43:27  valuev
 * fixed box flux calculation, reverted to russian documentation
 *
 * Revision 1.2  2012/03/21 17:17:53  lesha
 * documentation
 *
 * Revision 1.1  2012/02/15 19:49:42  lesha
 * moved to ivutils
 *
*******************************************************************************/

#include "ifmpi.h"

#ifndef USE_MPI

/// for serial version apMPIHandler is just empty class
class apMPIHandler{};

apMPIComm::apMPIComm():myrank(0),np(1),init(0),is_exit(0){
  _impl=new apMPIHandler;
}

apMPIComm::~apMPIComm(){
  if(init)Finalize();
  delete _impl;
}

#endif


int apMPIComm::Init(int argc, char **argv){
  int res=1;
#ifdef USE_MPI
  res=_mpiinit(argc,argv);
#endif
  init=1;
  return res;
}

int apMPIComm::Finalize(){
#ifdef USE_MPI
  _mpifinalize();
#endif
  init=0;
  return 1;
}

int apMPIComm::get_myrank(){
  return myrank;
}

int apMPIComm::get_nproc(){
  return np;
}

void apMPIComm::set_exit(){
  is_exit=1;
}

int apMPIComm::check_exit(){
#ifdef USE_MPI
  _mpicheck_exit();
#endif
  return is_exit;
}

apMPIComm theComm;
